# Submission Guideline

- Replace `XX` with your team number with leading zero (e.g. `02`).
- One submission *per team*.

## Build Test Submission

1. `cd` into your repository.
2. Commit all pending changes.
3. Checkout the revision you want to submit.
4. Ensure the submitted code builds.
5. Run the following command:

        $ git archive --prefix=team_XX_build_test/ --format=zip HEAD > team_XX_build_test.zip

6. Verify that the resulting archive contains everything you want to submit and nothing more.
7. Submit the archive via mail using the following line as subject (or link below).

        703602 - Team XX Build Test Submission

    📧 [send email](mailto:alexander.hirsch@uibk.ac.at?subject=703602%20-%20Team%20XX%20Build%20Test%20Submission)

## Final Submission

1. `cd` into your repository.
2. Commit all pending changes.
3. Checkout the revision you want to submit.
4. Ensure everything works.
    - Everything builds
    - No (unjustified) warnings
    - All unit tests succeed
    - All integration tests succeed
    - No memory is leaked
    - Known issues is present and up-to-date
5. Run the following command:

        $ git archive --prefix=team_XX_final/ --format=zip HEAD > team_XX_final.zip

6. Verify that the resulting archive contains everything you want to submit and nothing more.
7. Submit the archive via mail using the following line as subject (or link below).

        703602 - Team XX Final Submission

    📧 [send email](mailto:alexander.hirsch@uibk.ac.at?subject=703602%20-%20Team%20XX%20Final%20Submission)
